Notice
Recent Posts
Recent Comments
Link
일 | 월 | 화 | 수 | 목 | 금 | 토 |
---|---|---|---|---|---|---|
1 | 2 | 3 | 4 | |||
5 | 6 | 7 | 8 | 9 | 10 | 11 |
12 | 13 | 14 | 15 | 16 | 17 | 18 |
19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 |
Tags
- python Leetcode
- 상가수익률계산기
- 잇츠디모
- python 릿코드
- leetcode풀기
- python 알고리즘
- leetcode 풀기
- 릿코드풀기
- 코틀린기초
- python zip_longest
- 릿코드
- LeetCode
- 파이썬릿코드풀기
- leetcode풀이
- 파이썬 프로그래머스
- 알고리즘풀이
- 파이썬 알고리즘 풀기
- 파이썬알고리즘풀기
- 파이썬릿코드
- 릿코드풀이
- python sorted
- 파이썬알고리즘
- python xor
- 릿코드 풀기
- 파이썬 알고리즘
- python priority queue
- 파이썬 릿코드
- 알고리즘풀기
- 릿코드 파이썬
- binary search
Archives
- Today
- Total
소프트웨어에 대한 모든 것
2465. Number of Distinct Averages 본문
반응형
문제)
2465. Number of Distinct Averages
You are given a 0-indexed integer array nums of even length.
As long as nums is not empty, you must repetitively:
- Find the minimum number in nums and remove it.
- Find the maximum number in nums and remove it.
- Calculate the average of the two removed numbers.
The average of two numbers a and b is (a + b) / 2.
- For example, the average of 2 and 3 is (2 + 3) / 2 = 2.5.
Return the number of distinct averages calculated using the above process.
Note that when there is a tie for a minimum or maximum number, any can be removed.
Example 1:
Input: nums = [4,1,4,0,3,5]
Output: 2
Explanation:
1. Remove 0 and 5, and the average is (0 + 5) / 2 = 2.5. Now, nums = [4,1,4,3].
2. Remove 1 and 4. The average is (1 + 4) / 2 = 2.5, and nums = [4,3].
3. Remove 3 and 4, and the average is (3 + 4) / 2 = 3.5.
Since there are 2 distinct numbers among 2.5, 2.5, and 3.5, we return 2.
Example 2:
Input: nums = [1,100]
Output: 1
Explanation:
There is only one average to be calculated after removing 1 and 100, so we return 1.
Constraints:
- 2 <= nums.length <= 100
- nums.length is even.
- 0 <= nums[i] <= 100
솔루션1)
- 오름차순 정렬해서 제일 왼쪽은 min val, 제일 오른쪽은 max val을 쉽게 구할 수 있음
class Solution:
def distinctAverages(self, nums: List[int]) -> int:
nums.sort()
avgs = []
while nums:
avg = (nums[0] + nums[-1]) / 2
avgs.append(avg)
del nums[0]
nums.pop()
return len(set(avgs))
솔루션2)
- 솔루션1 최적화
: 리스트의 원소를 삭제하지 않고 left, right 인덱스 이동
: 불필요한 나누기 2 연산 제거
class Solution:
def distinctAverages(self, nums: List[int]) -> int:
nums.sort()
l, r = 0, len(nums) - 1
averages = []
while l < r:
averages.append(nums[l] + nums[r])
l += 1
r -= 1
return len(set(averages))
반응형
'알고리즘 > LeetCode' 카테고리의 다른 글
2396. Strictly Palindromic Number (0) | 2022.12.23 |
---|---|
1476. Subrectangle Queries (0) | 2022.12.23 |
504. Base 7 (0) | 2022.12.23 |
173. Binary Search Tree Iterator (0) | 2022.12.23 |
496. Next Greater Element I (0) | 2022.12.18 |
Comments